#include <windows.h>
#include "helputil.h"

static HelpInstance	HI;
static char buffer[200];
static char buffer2[200];

static LPSTR get_filename( LPSTR s)
{
	LPSTR	p;
	int		pos=-1;
	
	for(p=s; *p;p++)
		if (*p=='\\')
			pos = (int)(p-s);
	if (pos<0)
		return s;
	return s+pos+1;
}

void FAR PASCAL _export HUExecProgram (LPSTR Prog, LPSTR Arg, LPSTR Topico, WORD State)
{          
	HLOCAL			Rover = HelpList;
	HelpInstance	*This;
	HLOCAL			hLoc;
	int				pos;
		
	lstrcpy( buffer2, Prog );
	if( (!lstrcmpi(buffer2, "winhelp")) || (!lstrcmpi(buffer2, "winhelp.exe")) )
		{
		if( *Topico )
			{
			lstrcpy( buffer, "JI(`" );
			lstrcat( buffer, Arg );
			lstrcat( buffer, "\', `" );
			lstrcat( buffer, Topico );
			lstrcat( buffer, "\')" );
			}
		pos = (int)(get_filename(Arg)-Arg);
		while(Rover)
			{        
			int		equal;
			
			This = (HelpInstance *) LocalLock( Rover );
			hLoc = Rover;
			Rover   = This->Next;
			if (pos==0)
				equal = !lstrcmpi( get_filename(This->HelpFile), Arg );
			else
				equal = !lstrcmpi( This->HelpFile, Arg );
			if ( equal )
				{
				HWND hWnd =(HWND)This->LGetInfo(GI_MAINHWND, NULL );
				BringWindowToTop( hWnd );
				if(IsIconic( hWnd ) )
					ShowWindow( hWnd, SW_RESTORE );
				if ( *Topico )
					This->WinHelp( Arg, HELP_COMMAND, (DWORD)(void FAR *)buffer );
				LocalUnlock( hLoc );
				return;
				}
			LocalUnlock( hLoc );
			}
		lstrcat( buffer2, " ");
		lstrcat( buffer2, Arg );
		WinExec( buffer2, State );
		if(*Topico)
			{
			WinHelp( NULL, Arg, HELP_COMMAND, (DWORD)(void FAR *)buffer );
			for(Rover=HelpList;;)
				{        
				int		equal;
				
				This = (HelpInstance *) LocalLock( Rover );
				hLoc = Rover;
				Rover   = This->Next;
				if (pos==0)
					equal = !lstrcmpi( get_filename(This->HelpFile), Arg );
				else
					equal = !lstrcmpi( This->HelpFile, Arg );
				if ( equal )
					{
					HWND hWnd =(HWND)This->LGetInfo(GI_MAINHWND, NULL );
					This->WinHelp( Arg, HELP_COMMAND, (DWORD)(void FAR *)buffer );
					LocalUnlock( hLoc );
					return;
					}
				LocalUnlock( hLoc );
				}
			}
		return;
		}
	lstrcat( buffer2, " ");
	lstrcat( buffer2, Arg );
	WinExec( buffer2, State );
}

void FAR PASCAL _export HUEP (LPSTR Prog, LPSTR Arg, LPSTR Topico, WORD State)
{          
	HUExecProgram (Prog, Arg, Topico, State);
}

void FAR PASCAL _export HUExecProgram2 (LPSTR Prog, LPSTR Arg, LPSTR Janela, WORD State )
{          

	HWND			hWnd;
		
	lstrcpy( buffer, Prog );
	lstrcat( buffer, " ");
	lstrcat( buffer, Arg );
	hWnd = FindWindow( NULL, Janela );
	if ( hWnd != NULL )
		{
		BringWindowToTop( hWnd );
		if(IsIconic( hWnd ) )
			ShowWindow( hWnd, SW_RESTORE );
		}
	else
		WinExec( buffer, State );
}

void FAR PASCAL _export HUEP2 (LPSTR Prog, LPSTR Arg, LPSTR Janela, WORD State )
{          

	HUExecProgram2 ( Prog, Arg, Janela, State );
}

void FAR PASCAL _export HUDefineMain ()
{          
	HelpInstance		*ThisHelp;
	HLOCAL				hLoc;
	

	if(!InitDone)
		CheckRegistration();
	hLoc = CurrentHelpInstance(NULL);
	ThisHelp = (HelpInstance *)LocalLock( hLoc );
	ThisHelp->_IsMain = TRUE;
	LocalUnlock( hLoc );
}

void FAR PASCAL _export HUDMain ( )
{          

	HUDefineMain();
}

