#include <windows.h>
#include "helputil.h"

static HelpInstance	HI;
static char buffer[200]="";
static char buffer2[200]="";
char file_buffer[5000];

void FAR PASCAL _export HUTemporaryFont(LPSTR font, LPSTR Type)
{
    HF		        	fh;
    HFS					hFs;
	HelpInstance		*ThisHelp = &HI;
	HFILE				hf;
	OFSTRUCT			of;
	LONG				nBytes;
	
	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);

    hFs = OpenHelpFileSystem();
    if ( ! hFs )
    	return;
    fh = OpenHelpFile (hFs, font );
    if (!fh)
    	return;
    GetTempFileName(0, "tfn", 0, buffer);
	hf = OpenFile( buffer, &of, OF_CREATE | OF_WRITE );
	if ( hf == HFILE_ERROR )
		{
	    ThisHelp->RcCloseHf(fh);
		return;
		}
	for(;;)
		{
		nBytes = ThisHelp->LcbReadHf(fh, (LPSTR)file_buffer, sizeof( file_buffer ));
		if ( nBytes )
			_lwrite( hf, file_buffer, (UINT)nBytes );
		if (nBytes<sizeof( file_buffer ))
			break;
		}
    ThisHelp->RcCloseHf(fh);
	_lclose( hf );
	*buffer2='\0';
	if (*Type=='T')
		{
		int i;
		
		lstrcpy( buffer2, buffer );
		i = lstrlen( buffer2 );
		while(i>0)
			{
			if (*(buffer2+i)=='.')
				break;
			i--;
			}
		if(i>0)
			lstrcpy(buffer2+i+1, "fot");                       
		CreateScalableFontResource( 0, buffer2, buffer, NULL );
		AddFontResource( buffer2 );
		}
	else
		AddFontResource( buffer );
}

void FAR PASCAL CloseTempFont()
{
	OFSTRUCT			of;

	if (*buffer)
		{
		RemoveFontResource((*buffer2)?buffer2:buffer);
		OpenFile( buffer, &of, OF_DELETE );
		if(*buffer2)
			OpenFile( buffer2, &of, OF_DELETE );
		}
	*buffer='\0';
}

void FAR PASCAL _export HUTF(LPSTR font, LPSTR Type)
{
	HUTemporaryFont(font, Type);
}
