#include "windows.h"
#include "resource.h"

int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);
long CALLBACK __export MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL __export CALLBACK About(HWND, unsigned, WORD, LONG);
DWORD CALLBACK HookProc( int, WPARAM, LPARAM );

HANDLE hInst;

HWND hDialogo=NULL;                                
                                
int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
    MSG msg;  

    if (!hPrevInstance)
    if (!InitApplication(hInstance))
        return (FALSE);
        
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);
    while (GetMessage(&msg,NULL,NULL,NULL))
    {  
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
    return (msg.wParam);
}

BOOL InitApplication(hInstance)
HANDLE hInstance;
{
    WNDCLASS  wc;

    wc.style = NULL;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = "cMainWindow";

    return (RegisterClass(&wc));

}

BOOL InitInstance(hInstance, nCmdShow)
    HANDLE          hInstance;
    int             nCmdShow;
{
    HWND            hWnd;

    hInst = hInstance;

    hWnd = CreateWindow("cMainWindow",
        "Exemplo",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,
        CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL);
    if (!hWnd)
        return (FALSE);
    ShowWindow(hWnd, SW_HIDE);
    UpdateWindow(hWnd);
    return (TRUE);

}

long CALLBACK __export MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{
   switch (message)
      {
      case WM_CREATE:
         DialogBox(hInst,"AboutBox",hWnd,About);
         DestroyWindow( hWnd );
         break;                                                 
      case WM_DESTROY:
         PostQuitMessage(0);
         break;                                                 
      default:
         return (DefWindowProc(hWnd, message, wParam, lParam));  
      }
   return (NULL);
}

BOOL __export CALLBACK About(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WORD wParam;
LONG lParam;
{
   switch (message)
      {
      case WM_INITDIALOG:
         hDialogo = hDlg;
         return (TRUE);
      case WM_KEYUP:
         if ( wParam == VK_F1 )
            MessageBox( hDlg, "Edit", "Teste", 0 );
         break;
      case WM_COMMAND:
         switch(wParam)   
            {
            case IDOK:
            case IDCANCEL:
               EndDialog(hDlg, TRUE);
               return (TRUE);
            case IDM_HELP:
               break;
            default:
               break;
            }
         break;
      }
   return (FALSE);
}