#include <windows.h>
#include "helputil.h"
#include "resource.h"

#define MAX_LENGTH	2000    

char macro_buffer[MAX_LENGTH];
char macro_buffer2[MAX_LENGTH];

void FAR PASCAL _export HUMultiMacro (LPSTR macro)
{
	char *s, *p, *q;
	static HelpInstance	HI;
	HelpInstance		*ThisHelp = &HI;
	
	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);

	if (lstrlen( (LPCSTR)macro ) >= MAX_LENGTH )
		{
		LoadString( hModule, IDS_MACROBUFFER, strBuffer, sizeof(strBuffer) );
		wsprintf( macro_buffer, strBuffer, MAX_LENGTH );
		LoadString( hModule, IDS_ERRORTITLE, strBuffer, sizeof(strBuffer) );
		MessageBox( GetActiveWindow(), macro_buffer, strBuffer, 0 );
		return;
		}
	// Cardinal substituido por aspas
	lstrcpy( (LPSTR)macro_buffer, (LPCSTR)macro );
	for( s=macro_buffer; *s; s++ )
		if (*s=='#')
			*s = '"';
	for(s=p=macro_buffer;*s;)
		{   
		BOOL InQuote = FALSE;
		for( ;*s; )
			{
			if (*s=='"')
				InQuote = ! InQuote;
			if (*s==':' && !InQuote)
				break;
			s++;
			}   
		for(q=macro_buffer2; p<s ; )
			* q++ = *p++;
		*q = '\0';
		if (*s)
			{
			s++;
			p++;
			}
		ThisHelp->WinHelp(ThisHelp->HelpFile, HELP_COMMAND, (DWORD)(void FAR *)macro_buffer2 );
		HelpYield();
		if (!*s)
			break;
		}
}

void FAR PASCAL _export HUMM (LPSTR macro)
{
	HUMultiMacro ( macro );
}