#include <windows.h>
#include <commdlg.h>
#include "helputil.h"
#include "resource.h"

static HelpInstance	HI;
static char buffer[200];
extern char file_buffer[5000];

static OPENFILENAME		ofn;

void FAR PASCAL _export HUExtractFile (LPSTR File, LPSTR NewName, LPSTR Path)
{
    HF		        	fh;
    HFS					hFs;
	HelpInstance		*ThisHelp = &HI;
	HFILE				hf;
	OFSTRUCT			of;
	LONG				nBytes;
	static char			b[100];

	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);

    hFs = OpenHelpFileSystem();
    if ( ! hFs )
    	return;
    fh = OpenHelpFile (hFs, File );
    if (!fh)
    	return;
    if(!*Path)
    	{
    	lstrcpy(buffer, (*NewName) ? NewName:File );
    	ofn.lStructSize=sizeof(OPENFILENAME);
    	ofn.hwndOwner=GetActiveWindow();
    	ofn.hInstance=hModule;
    	ofn.lpstrFilter="All Files (*.*)\0*.*\0Zip Files (*.zip)\0*.zip\0";
    	ofn.lpstrCustomFilter=NULL;
    	ofn.nMaxCustFilter=0;
    	ofn.nFilterIndex=0;
    	ofn.lpstrFile=buffer;
    	ofn.nMaxFile=200;
    	ofn.lpstrFileTitle=NULL;
    	ofn.nMaxFileTitle=0;
    	ofn.lpstrInitialDir=NULL;
		LoadString( hModule, IDS_OPENFILETITLE, b, sizeof(b) );
    	ofn.lpstrTitle=b;
    	ofn.Flags=OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
		LoadString( hModule, IDS_OPENFILEDEFEXT, strBuffer, sizeof(strBuffer) );
    	ofn.lpstrDefExt=strBuffer;
    	ofn.lpfnHook=NULL;
    	ofn.lpTemplateName=NULL;
    	if (!GetSaveFileName(&ofn))
    		return;
    	}
    else
    	{
   		lstrcpy( buffer, Path );
   		if (*(Path+lstrlen(Path)-1)!='\\')
   			lstrcat(buffer, "\\");
		lstrcat(buffer, (!*NewName)?File:NewName );
		}
	hf = OpenFile( buffer, &of, OF_CREATE | OF_WRITE );
	if ( hf == HFILE_ERROR )
		{
	    ThisHelp->RcCloseHf(fh);
		return;
		}
	for(;;)
		{
		nBytes = ThisHelp->LcbReadHf(fh, (LPSTR)file_buffer, sizeof( file_buffer ));
		if ( nBytes )
			_lwrite( hf, file_buffer, (UINT)nBytes );
		if (nBytes<sizeof( file_buffer ))
			break;
		}
    ThisHelp->RcCloseHf(fh);
	_lclose( hf );
}

void FAR PASCAL _export HUEF (LPSTR File, LPSTR NewName, LPSTR Path)
{
	HUExtractFile( File, NewName, Path );
}
