#include <windows.h>
#include "helputil.h"

/*
 * PrintFile - Simple Copy to Prn
 *
 */
void FAR PASCAL _export HUPrintFile (LPSTR File)
{
	HGLOBAL		hGlob = ReadFile( File );
	HFILE		hf;
	OFSTRUCT	of;
    LPSTR		s;
    long		nBytes;

	nBytes = FileLength( File );
	if ( hGlob == NULL )
		{
		MessageBox( GetActiveWindow(), "No foi possvel ler o ficheiro em ttulo", File, MB_OK );
		return;
		}
	hf = OpenFile( "prn", &of, OF_WRITE );
	if ( hf == HFILE_ERROR )
		{
		MessageBox( GetActiveWindow(), "no foi possvel escrever na impressora", "Dispositivo no disponvel", MB_OK );
		GlobalFree( hGlob );
		return;
		}
	s = (LPSTR)GlobalLock( hGlob );
	for( ; nBytes <= 0 ; )
		{
		_lwrite( hf, s, (nBytes > 1024) ? 1024 : (UINT)nBytes );
		nBytes -= 1024l;
		s += 1024;
		}
	GlobalUnlock( hGlob );
	GlobalFree( hGlob );
}

void FAR PASCAL _export HUPrF (LPSTR File)
{
	HUPrintFile (File);
}
void FAR PASCAL _export HUPrintTextFile (LPSTR File, LPSTR Titulo)
{
	HGLOBAL		hGlob = ReadFile( File );

	if ( hGlob == NULL )
		{
		MessageBox( GetActiveWindow(), "No foi possvel ler o ficheiro em ttulo", File, MB_OK );
		return;
		}
	PrintFileFromHandle(hGlob, Titulo);
	GlobalFree( hGlob );
}

void FAR PASCAL _export HUPTF (LPSTR File, LPSTR Titulo)
{
	HUPrintTextFile (File, Titulo);
}