#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <dos.h>
#include "commdlg.h"
#include "drivinit.h"
#include "cursos.h"
#include "rescurso.h"

static HelpInstance	HI;

#define	NFIELDS		8
#define	MAXLEN		200
int		Id[NFIELDS];
BOOL FAR PASCAL __export DadosDlgProc(HWND hwnd, WORD msg, WORD wParam, LONG lParam);
static char buffer[200];
static char buffer2[200];
extern char FAR NomeEmpresa[200];

UINT FAR PASCAL locCompleteData(BOOL Force)
{
	char		*s; 
	HFILE		hf;
	OFSTRUCT	of;
	int			i;
    BOOL		Complete;
    FARPROC		lpfnDados;
    UINT		ret;
    
    
	GetTempFileName( 0, "AAA", 0, strBuffer );
	hf = OpenFile( strBuffer, &of, OF_DELETE );
	for (s = strBuffer + strlen( strBuffer ); s > strBuffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcpy( s, "defpcl.txt");
	hf = OpenFile( strBuffer, &of, OF_READ );
	if ( hf == HFILE_ERROR )
		{
		hf = OpenFile( strBuffer, &of, OF_CREATE | OF_READWRITE );
		if ( hf == HFILE_ERROR )
			return FALSE;
		for(i=0;i<NFIELDS;i++)
			_lwrite( hf, "\r\n", 2 );
		_llseek( hf, 0l, 0 );
		}
	Complete = TRUE;
	for(i = 0; i<NFIELDS; i++ )
		{
		char	ch;
		int		n=0;
		
		for(;;)
			{
			if( _lread( hf, (LPSTR)&ch, 1 ) < 1 )
				break;
			if (ch == '\n' )
				break;
			if (ch != '\r' )
				n++;
			}
		if ( n==0 )
			{
			Complete = FALSE;
			break;
			}
		}
	_lclose( hf );
	if ( Complete && !Force)
		return TRUE;
    lpfnDados = MakeProcInstance (DadosDlgProc, hModule);
    if (!lpfnDados)
	    return FALSE;
	ret = DialogBox( hModule, "DADOS", GetActiveWindow(), lpfnDados );
	if( ret != 1 )
		{
		FreeProcInstance( lpfnDados );
		return ret;
		}
	FreeProcInstance( lpfnDados );
	return 1;
}

BOOL FAR PASCAL __export DadosDlgProc(HWND hwnd, WORD msg, WORD wParam, LONG lParam)
{
	switch (msg)
		{
		HFILE		hf;
		int			i;
		OFSTRUCT	of;
		BOOL		Complete;
		
		case	WM_INITDIALOG:
			hf = OpenFile( strBuffer, &of, OF_READ );
			if ( hf == HFILE_ERROR )
				return TRUE;
			Id[0] = IDC_NOME;
			Id[1] = IDC_MORADA;
			Id[2] = IDC_MORADA2;
			Id[3] = IDC_CODIGOPOSTAL;
			Id[4] = IDC_EMPRESA;
			Id[5] = IDC_CARGO;
			Id[6] = IDC_TELEFONE;
			Id[7] = IDC_FAX;
			for ( i=0; i<NFIELDS; i++ )
				{
				int		k;

				memset(file_buffer, 0, sizeof(file_buffer));		
				for( k=0; k< MAXLEN; k++ )
					{
					if (_lread( hf, file_buffer + k, 1 ) < 1 )
						break;
					if( file_buffer[k] == '\n' )
						{
						file_buffer[k] = '\0';
						if( k>0 && file_buffer[k-1] == '\r' )
							file_buffer[k-1]='\0';
						break;
						}
					}
				file_buffer[k] = '\0';
				SetDlgItemText( hwnd, Id[i], file_buffer );
				}
			_lclose( hf );
			return TRUE;
		case	WM_COMMAND:
			if( wParam == IDOK )
				{
				hf = OpenFile( strBuffer, &of, OF_READWRITE | OF_CREATE );
				if ( hf == HFILE_ERROR )
					return TRUE;
				Complete = TRUE;
				for ( i=0; i<NFIELDS; i++ )
					{
	
					GetDlgItemText( hwnd, Id[i], file_buffer, MAXLEN );
					_lwrite( hf, file_buffer, strlen(file_buffer) );
					if (strlen(file_buffer)==0)
						Complete = FALSE;
					_lwrite( hf, "\r\n", 2 );
					}
				_lclose( hf );
				EndDialog( hwnd, Complete ? 1 : 2 );
				}
			if( wParam == IDCANCEL )
				EndDialog( hwnd, FALSE );
		default:
			return FALSE;
		}
	return TRUE;
}

BOOL ReadLn( HFILE hf, char *s, int n )
{
	int		ch;
	char	*p=s;
	for(;;)
		{
		ch = ReadChar(hf);
		if( ch == EOF )
			break;
		if ( ch == '\n' )
			break;
		*p++ = ch;
		}
	if( ch != EOF )
		if ( p>s && *(p-1)=='\r' )
			*(p-1)='\0';
	return (ch!=EOF);
}

BOOL FAR PASCAL locBuildOutFile( char * Empresa )
{
	int				nTimes=0;
    HFILE			out;
	HFILE			inpE;
	HFILE			inpU;
    OFSTRUCT		of;
	char			*s;
	int				i;
    
    
	GetTempFileName( 0, "AAA", 0, strBuffer );
	inpE = OpenFile( strBuffer, &of, OF_DELETE );
	for (s = strBuffer + strlen( strBuffer ); s > strBuffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcat( strcpy( s, "defp" ), Empresa ), ".txt");
	strcpy( buffer, strBuffer );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcpy( s, "defppt.txt");
	strcpy( buffer2, strBuffer );
	for (s = buffer2 + strlen( buffer2 ); s > buffer2 ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcpy( s, "defpcl.txt");
	inpE = OpenFile( strBuffer, &of, OF_READ );
	if( inpE == HFILE_ERROR )
		return FALSE;
	out = OpenFile( buffer, &of, OF_CREATE | OF_READWRITE );
	if( out == HFILE_ERROR )
		{
		_lclose( inpE );
		return FALSE;
		}
	inpU = OpenFile( buffer2, &of, OF_READ );
	if( inpU == HFILE_ERROR )
		{
		_lclose( inpE );
		_lclose( out );
		return FALSE;
		}
	*NomeEmpresa='\0';
	for( ;; )
		{
		if(!ReadLn( inpE, file_buffer, sizeof(file_buffer )))
			break;
		if(*file_buffer == '#' && *(file_buffer+1)=='#' )
			break;
		if( (!*NomeEmpresa) && strlen(file_buffer)<200)
			strcpy(NomeEmpresa, file_buffer );
		_lwrite( out, file_buffer, strlen(file_buffer) );
		_lwrite( out, "\r\n", 2 );		
		}
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA1, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA2, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	for( ;; )
		{
		if(!ReadLn( inpE, file_buffer, sizeof(file_buffer )))
			break;
		if(*(file_buffer+4)!='X')
			continue;
		_lwrite( out, file_buffer+6, strlen(file_buffer+6) );
		_lwrite( out, "\r\n", 2 );		
		}
	_lclose( inpE );

	LoadString( hModule, IDS_LINHA3, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA4, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA5, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA6, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	LoadString( hModule, IDS_LINHA7, strBuffer, sizeof(strBuffer) );
	_lwrite( out, strBuffer, strlen(strBuffer) );
	_lwrite( out, "\r\n", 2 );		
	for( i=0;i<NFIELDS; i++ )
		{
		char *p;
		if(!ReadLn( inpU, file_buffer, sizeof(file_buffer )))
			break;
		switch(i)
			{
			case 0:
				_lwrite( out, file_buffer, strlen(file_buffer) );
				_lwrite( out, "\r\n", 2 );		
				LoadString( hModule, IDS_LINHA8, strBuffer, sizeof(strBuffer) );
				_lwrite( out, strBuffer, strlen(strBuffer) );
				_lwrite( out, "\r\n", 2 );		
				LoadString( hModule, IDS_LINHA9, strBuffer, sizeof(strBuffer) );
				_lwrite( out, strBuffer, strlen(strBuffer) );
				_lwrite( out, "\r\n", 2 );		
				p = "Nome:            ";
				break;
			case 1:
				p = "Morada:          ";
				break;
			case 2:
				p = "                 ";
				break;
			case 3:
				p = "Cdigo Postal:   ";
				break;
			case 4:
				p = "\r\nEmpresa:         ";
				break;
			case 5:
				p = "Cargo/Profisso: ";
				break;
			case 6:
				p = "Telefone:        ";
				break;
			case 7:
				p = "Fax:             ";
				break;
			}
		_lwrite( out, p, strlen(p) );
		_lwrite( out, file_buffer, strlen(file_buffer) );
		_lwrite( out, "\r\n", 2 );		
		}
	_lclose( inpU );
	_lclose( out );
	return TRUE;
}