#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <dos.h>
#include "cursos.h"
#include "rescurso.h"

char FAR NomeEmpresa[200]="";
HANDLE hInitData=NULL;	/* handle to initialization data		 */

VOID FAR PASCAL PrintFileFromHandle(HGLOBAL hGlob, LPSTR s);
BOOL FAR PASCAL	locBuildOutFile( LPSTR Empresa );
BOOL UpdateItem( LPSTR Empresa, LPSTR Curso, short Estado );

#define GWW_HWNDEDIT	0
#define GWW_CHANGED	2
#define GWW_WORDWRAP	4
#define GWW_UNTITLED	6
#define CBWNDEXTRA	8

static HelpInstance	HI;

#define	MAXPROMPT	100
#define	MAXSTRS		20

typedef struct t_item
{
	BOOL	estado;
	BOOL	bakestado;
	BOOL	capturado;
	char	Prompt[MAXPROMPT+1];
	char	Curso[MAXSTRS+1];
	char	Empresa[MAXSTRS+1];
	DWORD   coFore;       /* Foreground color for this topic */
	DWORD   coBack;       /* Background color for this topic */
	HANDLE  hfs;          /* Handle to the current file system */
} ITEM, *ITEMP;

static BOOL Moving;
static BOOL iniState=FALSE;
static char buffer[MAXPROMPT+1];
static HWND	hWndFrame;

extern UINT FAR PASCAL locCompleteData( BOOL Force);

void FAR PASCAL _export CUCheckCurso( LPSTR Empresa, LPSTR Curso, short Estado )
{
	UpdateItem( Empresa, Curso, Estado );
}

void FAR PASCAL _export CUCC( LPSTR Empresa, LPSTR Curso, WORD Estado )
{
	CUCheckCurso( Empresa, Curso, Estado );
}

void FAR PASCAL _export CUPerfilUtilizador( )
{
	locCompleteData( TRUE );
}

void FAR PASCAL _export CUPU( )
{
	CUPerfilUtilizador( );
}

void FileCopy( HFILE hf, HF inp )
{
	long			nBytes;
	HelpInstance	* ThisHelp = &HI;
	
    if( hf == HFILE_ERROR || inp == NULL )
    	return;
	CurrentHelpInstance(ThisHelp);
    for( ;; )
    	{
    	nBytes = ThisHelp->LcbReadHf( inp, file_buffer, sizeof( file_buffer ) );
    	_lwrite( hf, file_buffer, (UINT)nBytes );
    	if( nBytes < sizeof( file_buffer ) )
    		break;
    	}
}

void ExtractEmpresa(char * Empresa, HANDLE hfs)
{
    HFILE		hf;
    OFSTRUCT	of;
    HF			inp;
	char		*s;
	
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcat( strcpy( s, "defp" ), Empresa ), ".txt");
	hf = OpenFile( buffer, &of, OF_READWRITE );
	if ( hf != HFILE_ERROR )
		{
		_lclose( hf );
		return;
		}
	hf = OpenFile( buffer, &of, OF_CREATE | OF_READWRITE );
	if ( hf == HFILE_ERROR )
		return;
	strcat( strcat( strcpy( strBuffer, "defp" ), Empresa ), ".txt");
	inp = OpenHelpFile( hfs, strBuffer );
	FileCopy( hf, inp );
	_lclose( hf );
	return;
}

BOOL UpdateItem( LPSTR Empresa, LPSTR Curso, short Estado )
{
	BOOL		First=TRUE;
	BOOL		Found = FALSE;
	int			ch;
	char		b[4], *s = b;
	HFILE		hf;
	OFSTRUCT	of;
	
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcat( strcpy( s, "defp" ), Empresa ), ".txt");
	hf = OpenFile( buffer, &of, OF_READWRITE );
	if ( hf == HFILE_ERROR )
		{
		_lclose( hf );
		return FALSE;
		}
	_llseek( hf, 0l, 0 );
	for( ; ; )
		{
		if( (ch=ReadChar(hf)) == EOF )
			break;
		if( ch == '\n' )
			{
			First = TRUE;
			continue;
			}
		if( First && ch == '#' )
			{
			if( (ch=ReadChar(hf)) == EOF )
				break;
			if( ch == '#' )
				{
				for( ; ch != '\n' && ch != EOF;  ch = ReadChar( hf ) );
				Found = TRUE;
				break;
				}
			if ( ch == '\n' )
				{
				First = TRUE;
				continue;
				}
			}
		First = FALSE;
		}
	if( !Found )
		{
		_lclose( hf );
		return FALSE;
		}
	for(s=b;;s=b)
		{
		if( ( *s++ = ReadChar( hf ) ) == EOF )
			break;
		if( ( *s++ = ReadChar( hf ) ) == EOF )
			break;
		if( ( *s++ = ReadChar( hf ) ) == EOF )
			break;
		*s = '\0';
		if ( !strcmp( b, Curso ) )
			{
			if( ( ch = ReadChar( hf ) ) == EOF )
				break;
			if( ch!= '\t' )
				break;
			if( ( ch = ReadChar( hf ) ) == EOF )
				break;
			if( ch != '#' && ch != 'X' )
				break;
			if ( Estado < 0 )
				{
				_lclose( hf );
				return (ch=='X');
				}
			_llseek( hf, -1l, 1 );
			_lwrite( hf, (Estado ? "X": "#"), 1 );
			break;
			}
		for( ch=' '; ch != '\n' && ch != EOF;  ch = ReadChar( hf ) );
		if(ch==EOF)
			break;
		}
	_lclose( hf );
	return FALSE;
}

void DrawWindowText2 (HWND hWnd, WORD n)
{
	TEXTMETRIC	tm;
	HLOCAL		hLoc;
	ITEMP		itemp;
	HDC			hdcBits;
	BITMAP		bm;
	HBITMAP		hbm;
	BOOL		f;
	HDC			dc = GetDC( hWnd );

	GetTextMetrics (dc, &tm);
	hLoc = (HLOCAL) n;
	itemp = (ITEMP) LocalLock( hLoc );
	hbm = LoadBitmap( hModule, MAKEINTRESOURCE(itemp->estado ? IDB_BTNON:IDB_BTNOFF));
	hdcBits = CreateCompatibleDC(dc);
	GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
	SelectObject(hdcBits,hbm);
	f = BitBlt(dc,0,1,bm.bmWidth,bm.bmHeight,hdcBits,0,0, SRCCOPY);
	DeleteDC(hdcBits);
	DeleteObject( hbm );
	SetBkMode( dc, TRANSPARENT );
	TextOut (dc, 18, 0,itemp->Prompt, lstrlen(itemp->Prompt));
	LocalUnlock( hLoc );
	ReleaseDC( hWnd, dc );
}

long FAR PASCAL _export CheckBoxProc2 (HWND hwnd,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
	static HFONT		hfont;
	static TEXTMETRIC	tm;
	static HLOCAL		hLoc;
	static ITEMP		itemp;
	static int			x, y;
	static RECT			rc;

	if(wParam!=WM_CREATE)
		{
		hLoc = GetWindowWord( hwnd, 0 );
		itemp = (ITEMP) LocalLock( hLoc );
		}
	switch (wMsg)
		{
		case WM_CREATE:
			{
			QCI			qci;
            char		*s, *t;
			HelpInstance		*ThisHelp = &HI;
            
			qci = (QCI)((CREATESTRUCT FAR *)lParam)->lpCreateParams;
			hLoc = LocalAlloc( LHND, sizeof( ITEM ) );
			itemp = (ITEMP)LocalLock( hLoc );
			itemp->estado = iniState;
			itemp->capturado = FALSE;
			itemp->coFore = qci->coFore;
			itemp->coBack = qci->coBack;
			itemp->hfs = qci->hfs;
			lstrcpy( buffer, qci->szAuthorData );
			for( s=buffer, t=itemp->Prompt; *s && *s!='_';)
				*t++ = *s++;
			*t = '\0';
			if ( *s='_' )
				s++;
			for( t=itemp->Empresa; *s && *s!='_';)
				*t++ = *s++;
			*t = '\0';
			if ( *s='_' )
				s++;
			for( t=itemp->Curso; *s && *s!='_';)
				*t++ = *s++;
			*t = '\0';
			SetWindowWord( hwnd, 0, (WORD)hLoc );
			SetClassWord( hwnd, GCW_HBRBACKGROUND, (WORD)CreateSolidBrush( itemp->coBack ));
			ExtractEmpresa(itemp->Empresa, itemp->hfs);
			itemp->estado = UpdateItem( itemp->Empresa, itemp->Curso, -1 );
			LocalUnlock( hLoc );     
			return 0;
			}

		case WM_PAINT :
			{
			PAINTSTRUCT ps;

			BeginPaint (hwnd, &ps);
			DrawWindowText2 (hwnd, GetWindowWord( hwnd, 0));
			EndPaint (hwnd, &ps);
			LocalUnlock( hLoc );
			return 0;
			}

		case EWM_RENDER :
			{
			switch (wParam)
				{
				case CF_BITMAP :
					{
					RECT rc;
					QRI qri;
					POINT pt;
					HBITMAP hbm, hbmDefault;
					HBRUSH hbrush;
					HDC hdc;

					qri = (QRI)lParam;
					hdc = CreateCompatibleDC (NULL);
					if (hdc != 0)
						{
						hfont = 0;

						SendMessage (hwnd, EWM_QUERYSIZE, (WPARAM)hdc,(LPARAM)(&pt));
						rc.left = 0;
						rc.top = 1;
						rc.right = pt.x;
						rc.bottom = pt.y+1;

						hbm = CreateCompatibleBitmap (qri->hdc, pt.x, pt.y);
						if (hbm != 0)
							{
							hbmDefault = SelectObject (hdc, hbm);
							hbrush = CreateSolidBrush (GetBkColor (hdc));
							if (hbrush != 0)
								{
								FillRect (hdc, &rc, hbrush);
								DeleteObject (hbrush);
								}
							Rectangle (hdc, rc.left, rc.top,rc.right, rc.bottom);
							DrawWindowText2 (hwnd,GetWindowWord( hwnd, 0));
							hbm = SelectObject (hdc, hbmDefault);
							}
						else
							hbm = NULL;
						DeleteDC (hdc);
						}
					LocalUnlock( hLoc );
					return (long)hbm;
					}

				default :
					LocalUnlock( hLoc );
					return 0;
				}
			}

		case EWM_QUERYSIZE :
			{
			LPPOINT lp;
    
			hfont = SelectObject ((HDC)wParam,GetStockObject (SYSTEM_FONT));
			GetTextMetrics ((HDC)wParam, &tm);
			lp = (LPPOINT)lParam;
			lp->x = 5+LOWORD (GetTextExtent ((HDC)wParam, itemp->Prompt,
				lstrlen (itemp->Prompt)));

			lp->x += tm.tmMaxCharWidth;
			lp->y = tm.tmHeight + tm.tmExternalLeading;
			if (hfont)
				SelectObject((HDC)wParam, hfont);
			LocalUnlock( hLoc );
			return 1;
			}
	    case WM_LBUTTONDOWN:
	    	{
	    	itemp->bakestado = itemp->estado;
	    	itemp->estado = !itemp->estado;
	    	itemp->capturado = TRUE;
	    	SetCapture( hwnd );
			DrawWindowText2 (hwnd, GetWindowWord( hwnd, 0));
	    	LocalUnlock( hLoc );
	    	return 0;
	    	}
	    case WM_LBUTTONUP:
	    	{
	    	if ( itemp->capturado )
	    		{                  
	    		int x, y;
	    		RECT rc; 
	    		
	    		GetClientRect( hwnd, &rc );
		    	ReleaseCapture(  );
		    	x = LOWORD(lParam);
		    	y = HIWORD( lParam );
		    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
		    		{
		    		if ( itemp->estado!=itemp->bakestado )
		    			{
			    		itemp->estado = !itemp->estado;
						DrawWindowText2 (hwnd, GetWindowWord( hwnd, 0));
		    			}
		    		}
		    	itemp->capturado = FALSE;
		    	}
				UpdateItem( itemp->Empresa, itemp->Curso, itemp->estado );
	    	}
			LocalUnlock( hLoc );
	    	return 0;
	    case WM_MOUSEMOVE:
	    	{ 
	    	if (!Moving)
	    		{
	    		Moving = TRUE;
		    	if ( itemp->capturado )
		    		{                  
		    		GetClientRect( hwnd, &rc );
			    	x = LOWORD(lParam);
			    	y = HIWORD( lParam );
			    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
			    		{                         
			    		if( itemp->bakestado != itemp->estado )
			    			{
				    		itemp->estado = itemp->bakestado;
							DrawWindowText2 (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	else
			    		{                         
			    		if( itemp->bakestado == itemp->estado )
			    			{
				    		itemp->estado = !itemp->estado;
							DrawWindowText2 (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	}
		    	}
		    	Moving = FALSE;
		    }
			LocalUnlock( hLoc );
	    	return 0;
	    case WM_RBUTTONDOWN:
	    	return 0;
		case BM_GETCHECK:
			{
			BOOL estado=itemp->estado;
			
			LocalUnlock( hLoc );
			return estado;
			}
		case WM_DESTROY:
			{
			LocalUnlock( hLoc );
			LocalFree( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
			}
		default :    
			LocalUnlock( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
		}
}

void FAR PASCAL _export CUApagaInformacoesCorrentes(LPSTR Empresa)
{
    HFILE			hf;
    OFSTRUCT		of;
	char			*s;
	HelpInstance	* ThisHelp = &HI;
	
	CurrentHelpInstance(ThisHelp);
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcat( strcpy( s, "defp" ), Empresa ), ".txt");
	hf = OpenFile( buffer, &of, OF_DELETE );
}

void FAR PASCAL _export CUAIC(LPSTR Empresa)
{
	CUApagaInformacoesCorrentes(Empresa);
}


void FAR PASCAL _export CUApagaInformacoes()
{
    HFILE			hf;
    OFSTRUCT		of;
	char			*s;
	HelpInstance	* ThisHelp = &HI;
	struct _find_t	ft;
	
	CurrentHelpInstance(ThisHelp);
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcpy( s, "defp??" ), ".txt");
	if(!_dos_findfirst( buffer, _A_NORMAL, &ft ))
		for(;;)
			{
			*s='\0';
			strcat(buffer, ft.name );
			hf = OpenFile( buffer, &of, OF_DELETE );
			if(_dos_findnext( &ft ) )
				break;
			}
}

void FAR PASCAL _export CUAI()
{
	CUApagaInformacoes();
}

HGLOBAL ReadTextFile( )
{
	HGLOBAL			hGlob = GlobalAlloc( GHND, sizeof(file_buffer)+1 );
	LPSTR			Texto;
	int				nTimes=0;
    HFILE			hf;
    OFSTRUCT		of;
	char			*s;
	HelpInstance	* ThisHelp = &HI;
	
	CurrentHelpInstance(ThisHelp);
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcpy( s, "defppt.txt");
	hf = OpenFile( buffer, &of, OF_READ );
	if( hf == HFILE_ERROR )
		return NULL;
	for( ;; )
		{
		long	nBytes;
		
		Texto = GlobalLock( hGlob );
		nBytes = _lread( hf, Texto + nTimes*sizeof(file_buffer),
									sizeof(file_buffer) );
		*(Texto + nTimes*sizeof(file_buffer) + nBytes ) = '\0';
		GlobalUnlock( hGlob );
		if ( nBytes < sizeof(file_buffer) )
			break;
		nTimes ++;
		hGlob = GlobalReAlloc( hGlob, (nTimes+1) * sizeof(file_buffer)+1,
								GMEM_MOVEABLE );
		}
	_lclose( hf );
	return hGlob;
}

void FAR PASCAL _export CUPrintInformacoesCorrentes(LPSTR Empresa)
{
	HelpInstance	* ThisHelp = &HI;
	HGLOBAL			hGlob;
	void			ResetPrinter();
	UINT			ret;
	
	ret = locCompleteData(FALSE);
	if(ret == 0)
		return;
	if( ret == 2 )
		{
		LoadString( hModule, IDS_DADOS_INC, strBuffer, sizeof(strBuffer) );
		MessageBox( GetActiveWindow(), strBuffer, "Erro", 0 );
		return;
		}
	if(!locBuildOutFile( Empresa ))
		return;
	CurrentHelpInstance(ThisHelp);
	hWndFrame = (HWND)ThisHelp->LGetInfo( GI_MAINHWND, NULL );
	hGlob = ReadTextFile( );
	if( hGlob == NULL )
		return;
    strcpy(strBuffer, "Empresa - ");
    strcat(strBuffer, NomeEmpresa);
	PrintFileFromHandle( hGlob, strBuffer );
	GlobalUnlock( hGlob );
	GlobalFree( hGlob );
	ResetPrinter();
}

void FAR PASCAL _export CUPIC(LPSTR Empresa)
{
	CUPrintInformacoesCorrentes(Empresa);
}

void FAR PASCAL _export CUPrintInformacoes()
{
	HelpInstance	* ThisHelp = &HI;
    HFILE			hf;
	HGLOBAL			hGlob;
    OFSTRUCT		of;
	char			*s;
	struct _find_t	ft;
	char			Empresa[3];
	BOOL			CanceledPrinter();
	UINT			ret;
	
	ret = locCompleteData(FALSE);
	if(ret == 0)
		return;
	if( ret == 2 )
		{
		LoadString( hModule, IDS_DADOS_INC, strBuffer, sizeof(strBuffer) );
		MessageBox( GetActiveWindow(), strBuffer, "Erro", 0 );
		return;
		}
	CurrentHelpInstance(ThisHelp);
	GetTempFileName( 0, "AAA", 0, buffer );
	hf = OpenFile( buffer, &of, OF_DELETE );
	for (s = buffer + strlen( buffer ); s > buffer ; s-- )
		if( *s == '\\' )
			break;
	if( *s == '\\' )
		s++;
	strcat( strcpy( s, "defp??" ), ".txt");
	CurrentHelpInstance(ThisHelp);
	hWndFrame = (HWND)ThisHelp->LGetInfo( GI_MAINHWND, NULL );
	if(!_dos_findfirst( buffer, _A_NORMAL, &ft ))
		for(;;)
			{
			char	c1, c2;
			
			c1 = Empresa[0] = ft.name[4];
			c2 = Empresa[1] = ft.name[5];
			Empresa[2] = '\0';
			if( c1 >= '0' && c1 <= '9' && c2 >= '0' && c2 <= '9' )
				{
				if(!locBuildOutFile( Empresa ))
					break;
				hGlob = ReadTextFile( );
				if( hGlob == NULL )
					break;
			    strcpy(strBuffer, "Empresa - ");
    			strcat(strBuffer, NomeEmpresa);
				PrintFileFromHandle( hGlob, strBuffer );
				GlobalUnlock( hGlob );
				GlobalFree( hGlob );
				if ( CanceledPrinter() )
					break;
				}
			if(_dos_findnext( &ft ) )
				break;
			}
	ResetPrinter();
}

void FAR PASCAL _export CUPI()
{
	CUPrintInformacoes();
}