#include <windows.h>
#include <ctl3d.h>
#include <string.h>
#include "helputil.h"
#include "resource.h"

void FAR PASCAL _export HUEnable3d( WORD Enable )
{
	HelpInstance		*ThisHelp;
	HLOCAL				hLoc;
	

	if(!InitDone)
		CheckRegistration();
	hLoc = CurrentHelpInstance(NULL);
	ThisHelp = (HelpInstance *)LocalLock( hLoc );
	if(Enable)
		{
		if( !ThisHelp->_3dEnabled )
			{
			Ctl3dRegister(hModule);
			Ctl3dAutoSubclass(hModule);
			ThisHelp->_3dEnabled = TRUE;
			}
		}
	else
		{
		if( ThisHelp->_3dEnabled )
			{
          	Ctl3dUnregister(hModule);
			ThisHelp->_3dEnabled = FALSE;
			}
		}
	LocalUnlock( hLoc );
}