#include <windows.h>
#include <string.h>

#define		MODE_2				1
#define		MODE_16				2
#define		MODE_256			3
#define		MODE_640x480		4
#define		MODE_800x600		5
#define		MODE_1024x768		6
#define		MODE_LargeFonts		7
#define		MODE_SmallFonts		8
char 		file_buffer[200];


BOOL FAR PASCAL _export WSis16 ()
{   
	HDC		hDc;
	int		Caps;
	HWND	wnd=GetActiveWindow();
	                            
	hDc = GetDC( wnd );
	Caps = GetDeviceCaps( hDc, NUMCOLORS );
	ReleaseDC(wnd, hDc );
	if (Caps == 16)
		return TRUE;
	else
		return FALSE;
}

BOOL FAR PASCAL _export WSisMode (UINT Mode)
{   
	HDC		hDc;
	int		Caps;
	int		horPixel;
	HWND	wnd=GetActiveWindow();
	int		dpis;
	
	hDc = GetDC( wnd );
	Caps = GetDeviceCaps( hDc, NUMCOLORS );
	dpis = GetDeviceCaps( hDc, LOGPIXELSX );
	horPixel = GetSystemMetrics( SM_CXSCREEN );
	ReleaseDC(wnd, hDc );
	switch (Mode)
		{
			case MODE_2:
				return Caps == 2;
			case MODE_16:
				return Caps == 16;
			case MODE_256:
				return Caps >= 256;
			case MODE_640x480:
				return horPixel == 640;
			case MODE_800x600:
				return horPixel == 800;
			case MODE_1024x768:
				return horPixel >= 1024;
			case MODE_LargeFonts:
				return dpis>=108;
			case MODE_SmallFonts:
				return dpis<108;
		}
}

BOOL FAR PASCAL _export WSISM (UINT Mode)
{
	return WSisMode ( Mode);
}