#include <windows.h>
#include <time.h>
#include "registo.h"

static HFILE FilePointer=HFILE_ERROR;

static time_t	CurrentTime=0l;
static time_t	TopicEnterTime=0l;

BOOL FAR PASCAL _export trRegisterFile( LPCSTR File )
{
	HFILE		hf;
	OFSTRUCT	of;

	hf = OpenFile( File, &of, OF_CREATE|OF_WRITE );
	if ( hf == HFILE_ERROR )
		return FALSE;
	FilePointer = hf;
	return TRUE;
}

static char b[30];

void FAR PASCAL _export trEnterContents(LPSTR Id)
{
	if ( FilePointer==HFILE_ERROR )
		return;
	CurrentTime = time(NULL);
	wsprintf( b, "\t%ld", CurrentTime - TopicEnterTime );
	TopicEnterTime = CurrentTime;
	if (_llseek( FilePointer, 0l, 1 ) != 0l )
		{
		_lwrite( FilePointer, b, lstrlen(b ) );
		_lwrite( FilePointer, "\r\n", 2 );
		}
	_lwrite( FilePointer, Id, lstrlen(Id ) );
	CurrentTime = TopicEnterTime = time(NULL);
}

void FAR PASCAL _export trEnterTopic( LPSTR Id )
{                                            
	if ( FilePointer==HFILE_ERROR )
		return;
	CurrentTime = time(NULL);
	wsprintf( b, "%ld", CurrentTime - TopicEnterTime );
	TopicEnterTime = CurrentTime;
	_lwrite( FilePointer, "\t", 1 );
	_lwrite( FilePointer, b, lstrlen(b ) );
	_lwrite( FilePointer, "\t", 1 );
	_lwrite( FilePointer, Id, lstrlen(Id ) );
}

void FAR PASCAL _export trCloseFile()
{
	if ( FilePointer==HFILE_ERROR )
		return;
	_lclose( FilePointer );
	FilePointer = HFILE_ERROR;
}