#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <sys\locking.h>
#include <share.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

void main(int argc, char *argv[] )
{
	int i;
	int Unlock=0;
	
	if(argc<2)
		{
		printf("utilizacao: lock [-u] file1 [ file2 ... ]\n");
		exit(1);
		}
	if(*argv[1] == '-' )
		{
		if(*(argv[1]+1)!='u')
			{
			printf("utilizacao: lock [-u] file1 [ file2 ... ]\n");
			exit(1);
			}
		Unlock=1;
		for (i=1;i<argc;i++)
			argv[i] = argv[i+1];
		argc--;
		}
	if(argc<2)
		{
		printf("utilizacao: lock [-u] file1 [ file2 ... ]\n");
		exit(1);
		}
	for(i=1;i<argc;i++)
		{
		int fh = _sopen( argv[i], _O_RDWR, _SH_DENYWR );
		if( fh >= 0 )
			{
			_locking( fh, Unlock ? _LK_UNLCK : _LK_LOCK, 10l );
//			_close(fh);
			}
		}
	_exit(0);
}