#include <windows.h>
#include "helputil.h"
#include "code.h"

#define		NOREGISTRATION()	\
					{\
					extern void ShowNoRegistration();\
\
					ShowNoRegistration();\
					return;\
					}

static HelpInstance	HI;
extern char file_buffer[5000];
unsigned long ReverseCode(char  *s);

void CheckRegistration (void)
{

    HF		        	fh;
    HFS					hFs;
	HelpInstance		*ThisHelp = &HI;
	LONG				nBytes;
	char				* s, *p;
	unsigned long		CheckVal;

	if(InitDone)
		return;
	InitDone = TRUE;
	CurrentHelpInstance(ThisHelp);

    hFs = OpenHelpFileSystem();
    if ( ! hFs )
    	return;
    fh = OpenHelpFile (hFs, "serial.reg" );
    if (!fh)
		NOREGISTRATION()
	nBytes = ThisHelp->LcbReadHf(fh, (LPSTR)file_buffer, sizeof( file_buffer ));
    ThisHelp->RcCloseHf(fh);
	if (nBytes<14)
		NOREGISTRATION()

//	Read in the name
	for(s=file_buffer,p=strBuffer;*s;s++)
		{
		if(*s==',')
			break;
		*p++=*s;
		}
	if (!*s)
		NOREGISTRATION()
	*p ='\0';
	for(p--;p>strBuffer;p--)
		if (*p!=' ')
			break;
	*(p+1)='\0';
	for(p=strBuffer;*p;p++)
		if(*p!=' ')
			break;
	CheckVal=CalculateCheckValue(p);
	if(*s)
		s++;
	for(;*s && *s==' ';s++);
	p = s;
	for(;*s && *s!=' ';s++);
	*s='\0';
	for(;s>p && *(s-1)<32;s--);
	*s='\0';                    
	if ((s-p)!=15)
		NOREGISTRATION();
	s = strBuffer;
	*s++=*(p+13);
	*s++=*(p+14);
	*s++=*(p+2);
	*s++=*(p+3);
	*s++=*(p+8);
	*s++=*(p+9);
	*s++=*(p+4);
	*s++=*(p+5);
	*s='\0';
	if( CheckVal!=ReverseCode(strBuffer) )
		NOREGISTRATION();
}


unsigned long ReverseCode( char * s )
{
	unsigned long val=0;
	unsigned long mul=1;
	
	for(;*s;s++)
		{
		val += mul*( ( *s>='0' && *s<='9' ) ? (*s-'0') : (*s-'A'+10) );
		mul *= 26;
		}
	return val;
}

BOOL FAR PASCAL NoRegistrationProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
		{
		case WM_INITDIALOG:
			return (TRUE);

		case WM_COMMAND:
			if (wParam == IDOK || wParam == IDCANCEL)
				{
				EndDialog(hDlg, TRUE);
				return (TRUE);
				}
			break;
		}
	return (FALSE);
}

void ShowNoRegistration()
{

	FARPROC lpProcAbout;
	int		i;

	lpProcAbout = MakeProcInstance(NoRegistrationProc, hModule);
	if(	DialogBox(hModule,"NOTINSTALLED",GetActiveWindow(),lpProcAbout)<0)
		{          
		for(i=0;;i++)
			{
			char	*s;
			int		j;

			j = i%5;
			switch (j)
				{
				case 0:
					s = "Bad Boy";
					break;
				case 1:
					s = "You shouldn\'t delete the Dialog Box";
					break;
				case 2:
					s = "A believe you know you\'re violating international agreaments";
					break;
				case 3:
					s = "Okay, put back the Dialog and I\'ll go away";
					break;
				case 4:
					s = "See you";
					break;
				}
			MessageBox( GetActiveWindow(), s, "Rape", MB_OK|MB_ICONSTOP);
			}
		}
}
